# -*- coding: utf-8 -*-


def get_download_url(upload_file):
    folder = "uploads"
    fullfilename = db.upload.upload_file.retrieve(
        upload_file, nameonly=True)[1]
    filename = fullfilename[fullfilename.find(folder) + len(folder) + 1:]
    filename = filename.replace("\\", "/")
    return URL("download", args=filename)


def index():
    return {}


def upload_file():
    """
    Esta función es invocada vía AJAX por el plugin dmuploader.
    """
    if request.env.request_method != "POST":
        raise HTTP(404)
    upload_file = db.upload.upload_file.store(
        request.post_vars.file,
        filename=request.post_vars.file.filename
    )
    db.upload.insert(upload_file=upload_file)
    return response.json({
        "status": "ok",
        "path": get_download_url(upload_file)
    })


@cache.action()
def download():
    """
    allows downloading of uploaded files
    http://..../[app]/default/download/[filename]
    """
    return response.download(request, db)

